diff --git a/src/main/java/net/minecraft/client/render/model/ZombieModel.java b/src/main/java/net/minecraft/client/render/model/ZombieModel.java
index 279401957..942e0cfa8 100644
--- a/src/main/java/net/minecraft/client/render/model/ZombieModel.java
+++ b/src/main/java/net/minecraft/client/render/model/ZombieModel.java
@@ -32,20 +32,20 @@ public class ZombieModel extends BipedModel {
         this.body = new Cube(16, 16);
         this.body.addBox(-4.0F, 0.0F, -2.0F, 8, 12, 4, var1);
         this.body.setRotationPoint(0.0F, 0.0F + var2, 0.0F);
-        this.arm0 = new Cube(40, 16);
-        this.arm0.addBox(-3.0F, -2.0F, -2.0F, 4, 12, 4, var1);
-        this.arm0.setRotationPoint(-5.0F, 2.0F + var2, 0.0F);
-        this.arm1 = new Cube(40, 16);
-        this.arm1.mirror = true;
-        this.arm1.addBox(-1.0F, -2.0F, -2.0F, 4, 12, 4, var1);
-        this.arm1.setRotationPoint(5.0F, 2.0F + var2, 0.0F);
-        this.leg0 = new Cube(0, 16);
-        this.leg0.addBox(-2.0F, 0.0F, -2.0F, 4, 12, 4, var1);
-        this.leg0.setRotationPoint(-2.0F, 12.0F + var2, 0.0F);
-        this.leg1 = new Cube(0, 16);
-        this.leg1.mirror = true;
-        this.leg1.addBox(-2.0F, 0.0F, -2.0F, 4, 12, 4, var1);
-        this.leg1.setRotationPoint(2.0F, 12.0F + var2, 0.0F);
+        this.armRight = new Cube(40, 16);
+        this.armRight.addBox(-3.0F, -2.0F, -2.0F, 4, 12, 4, var1);
+        this.armRight.setRotationPoint(-5.0F, 2.0F + var2, 0.0F);
+        this.armLeft = new Cube(40, 16);
+        this.armLeft.mirror = true;
+        this.armLeft.addBox(-1.0F, -2.0F, -2.0F, 4, 12, 4, var1);
+        this.armLeft.setRotationPoint(5.0F, 2.0F + var2, 0.0F);
+        this.legRight = new Cube(0, 16);
+        this.legRight.addBox(-2.0F, 0.0F, -2.0F, 4, 12, 4, var1);
+        this.legRight.setRotationPoint(-2.0F, 12.0F + var2, 0.0F);
+        this.legLeft = new Cube(0, 16);
+        this.legLeft.mirror = true;
+        this.legLeft.addBox(-2.0F, 0.0F, -2.0F, 4, 12, 4, var1);
+        this.legLeft.setRotationPoint(2.0F, 12.0F + var2, 0.0F);
     }
 
     @Override
@@ -53,23 +53,23 @@ public class ZombieModel extends BipedModel {
         super.setupAnimation(limbSwing, limbYaw, limbPitch, headYaw, headPitch, scale);
         float var7 = MathHelper.sin(this.onGround * 3.1415927F);
         float var8 = MathHelper.sin((1.0F - (1.0F - this.onGround) * (1.0F - this.onGround)) * 3.1415927F);
-        this.arm0.zRot = 0.0F;
-        this.arm1.zRot = 0.0F;
-        this.arm0.yRot = -(0.1F - var7 * 0.6F);
-        this.arm1.yRot = 0.1F - var7 * 0.6F;
-        this.arm0.xRot = -1.5707964F;
-        this.arm1.xRot = -1.5707964F;
-        Cube var10000 = this.arm0;
+        this.armRight.zRot = 0.0F;
+        this.armLeft.zRot = 0.0F;
+        this.armRight.yRot = -(0.1F - var7 * 0.6F);
+        this.armLeft.yRot = 0.1F - var7 * 0.6F;
+        this.armRight.xRot = -1.5707964F;
+        this.armLeft.xRot = -1.5707964F;
+        Cube var10000 = this.armRight;
         var10000.xRot -= var7 * 1.2F - var8 * 0.4F;
-        var10000 = this.arm1;
+        var10000 = this.armLeft;
         var10000.xRot -= var7 * 1.2F - var8 * 0.4F;
-        var10000 = this.arm0;
+        var10000 = this.armRight;
         var10000.zRot += MathHelper.cos(limbPitch * 0.09F) * 0.05F + 0.05F;
-        var10000 = this.arm1;
+        var10000 = this.armLeft;
         var10000.zRot -= MathHelper.cos(limbPitch * 0.09F) * 0.05F + 0.05F;
-        var10000 = this.arm0;
+        var10000 = this.armRight;
         var10000.xRot += MathHelper.sin(limbPitch * 0.067F) * 0.05F;
-        var10000 = this.arm1;
+        var10000 = this.armLeft;
         var10000.xRot -= MathHelper.sin(limbPitch * 0.067F) * 0.05F;
     }
 }
\ No newline at end of file
diff --git a/src/main/java/net/minecraft/client/render/texturepack/TexturePack.java b/src/main/java/net/minecraft/client/render/texturepack/TexturePack.java
index 46d80c445..2b5b706a7 100644
--- a/src/main/java/net/minecraft/client/render/texturepack/TexturePack.java
+++ b/src/main/java/net/minecraft/client/render/texturepack/TexturePack.java
@@ -13,6 +13,7 @@ import java.util.stream.Stream;
 
 import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.holiday.Holidays;
 import org.slf4j.Logger;
 
 public abstract class TexturePack {
@@ -45,6 +46,12 @@ public abstract class TexturePack {
 
 	public InputStream getResourceAsStream(String s)
 	{
+		if (Holidays.getCurrentThemedHoliday() != null) {
+			assert Holidays.getCurrentThemedHoliday().getCustomResourcesSubPath() != null : "Current themed holiday must have a theme!";
+			String holidayPath = ("/holidays/" + Holidays.getCurrentThemedHoliday().getCustomResourcesSubPath() + "/" + s);
+			InputStream holidayStream = TexturePack.class.getResourceAsStream(holidayPath);
+			if (holidayStream != null) return holidayStream;
+		}
 		return TexturePack.class.getResourceAsStream(s);
 	}
 
diff --git a/src/main/java/net/minecraft/client/render/texturepack/TexturePackCustom.java b/src/main/java/net/minecraft/client/render/texturepack/TexturePackCustom.java
index aa7b7a23c..29b80487c 100644
--- a/src/main/java/net/minecraft/client/render/texturepack/TexturePackCustom.java
+++ b/src/main/java/net/minecraft/client/render/texturepack/TexturePackCustom.java
@@ -15,6 +15,7 @@ import java.util.zip.ZipFile;
 
 import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.holiday.Holidays;
 import net.minecraft.client.render.texture.BufferedTexture;
 import net.minecraft.client.render.texturepack.Manifest.ManifestException;
 import org.slf4j.Logger;
@@ -185,36 +186,47 @@ public class TexturePackCustom extends TexturePack
     @Override
 	public InputStream getResourceAsStream(String path)
     {
-    	if (file.isFile())
-    	{
+    	return getResourceAsStream(path, true);
+	}
+	private InputStream getResourceAsStream(String path, boolean firstCall)
+	{
+		if (firstCall && Holidays.getCurrentThemedHoliday() != null) {
+			assert Holidays.getCurrentThemedHoliday().getCustomResourcesSubPath() != null : "Current themed holiday must have a theme!";
+			String holidayPath = ("/holidays/" + Holidays.getCurrentThemedHoliday().getCustomResourcesSubPath() + "/" + path);
+			InputStream holidayStream = getResourceAsStream(holidayPath, false);
+			if (holidayStream != null) return holidayStream;
+		}
+
+		if (file.isFile())
+		{
 			String zipEntryPath = path;
 			if (path.startsWith("/")) zipEntryPath = path.substring(1);
-    		try
-    		{
-    			java.util.zip.ZipEntry zipentry = zipFile.getEntry(zipEntryPath);
-    			if(zipentry != null)
-    			{
-    				return zipFile.getInputStream(zipentry);
-    			}
-    		}
-    		catch(Exception ignored)
+			try
+			{
+				java.util.zip.ZipEntry zipentry = zipFile.getEntry(zipEntryPath);
+				if(zipentry != null)
+				{
+					return zipFile.getInputStream(zipentry);
+				}
+			}
+			catch(Exception ignored)
 			{
-    			return null;
+				return null;
 			}
 		}
-    	else
-    	{
-    		try
-    		{
-    			File file = new File(this.file, path);
-    			if (file.exists())
-    			{
-    				return Files.newInputStream(file.toPath());
-    			}
-    		}
-    		catch (Exception ignored)
+		else
+		{
+			try
+			{
+				File file = new File(this.file, path);
+				if (file.exists())
+				{
+					return Files.newInputStream(file.toPath());
+				}
+			}
+			catch (Exception ignored)
 			{
-    			return null;
+				return null;
 			}
 		}
 
diff --git a/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java b/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
index ae6498673..ff02b0730 100644
--- a/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
+++ b/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
@@ -2,6 +2,7 @@ package net.minecraft.client.render.texturepack;
 
 import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.holiday.Holidays;
 import net.minecraft.client.render.Font;
 import net.minecraft.client.sound.SoundRepository;
 import org.jetbrains.annotations.Nullable;
@@ -30,7 +31,7 @@ public class TexturePackList
 
 	public TexturePackList(Minecraft minecraft, File file) {
 		this.mc = minecraft;
-		
+
 		texturePackDir = new File(file, "texturepacks");
 		if(!texturePackDir.exists()) {
 			texturePackDir.mkdirs();
@@ -100,9 +101,9 @@ public class TexturePackList
 
 	public boolean updateAvailableTexturePacks() {
 		List<TexturePack> currentTexturePacks = new ArrayList<>();
-		
+
 		boolean update = false;
-		
+
 		if(texturePackDir.exists() && texturePackDir.isDirectory()) {
 			File[] filesArr = texturePackDir.listFiles();
 
@@ -130,12 +131,12 @@ public class TexturePackList
 							pack.packId = id;
 							pack.readZipFile();
 							pack.readTexturePackManifest();
-							
+
 							texturePackIDs.put(id, pack);
 							pack.closeTexturePackFile();
 							update = true;
 						}
-						
+
 						TexturePack pack = texturePackIDs.get(id);
 						currentTexturePacks.add(pack);
 					}catch (IOException e) {
@@ -146,16 +147,16 @@ public class TexturePackList
 		}
 		List<TexturePack> previousTexturePacks = this.availableTexturePacks;
 		previousTexturePacks.removeAll(currentTexturePacks);
-		
+
 		if(!previousTexturePacks.isEmpty()) {
 			update = true;
 		}
-		
+
 		for(TexturePack texturePack : previousTexturePacks) {
 			texturePack.disposeOfTexturePack(mc);
 			texturePackIDs.remove(texturePack.packId);
 		}
-		
+
 		this.availableTexturePacks = currentTexturePacks;
 
 		String[] packStrings = mc.gameSettings.skin.value.split(SEPERATOR);
@@ -170,7 +171,7 @@ public class TexturePackList
 
 		return update;
 	}
-	
+
 	/**
 	 * The Texture Pack ID is needed to detect when a texture pack has been changed and the GUI needs to update
 	 */
@@ -180,11 +181,11 @@ public class TexturePackList
 		}else {
 			File manifestFile = new File(file, "manifest.json");
 			File packPngFile = new File(file, "pack.png");
-			
+
 			return file.getName() + ":" + manifestFile.length() + ":" + manifestFile.lastModified() + ":" + packPngFile.length() + ":" + packPngFile.lastModified();
 		}
 	}
-	
+
 	private boolean isTexturePack(File file) {
 		if(file.isDirectory()) {
 			return new File(file, "pack.txt").exists() || new File(file, "manifest.json").exists();
@@ -207,6 +208,9 @@ public class TexturePackList
         return defaultTexturePack;
     }
 	public InputStream getResourceAsStream(String s){
+		return getResourceAsStream(s, true);
+	}
+	private InputStream getResourceAsStream(String s, boolean firstCall) {
 		InputStream stream;
 		for (int i = selectedPacks.size() - 1; i >= 0; i--) {
 			TexturePack pack = selectedPacks.get(i);
@@ -219,8 +223,11 @@ public class TexturePackList
 		if (selectedPacks.isEmpty()) return defaultTexturePack;
 		return selectedPacks.get(selectedPacks.size()-1);
 	}
-	
+
 	public @Nullable TexturePack getHighestPriorityTexturePackWithFile(String path) {
+		return getHighestPriorityTexturePackWithFile(path, true);
+	}
+	private @Nullable TexturePack getHighestPriorityTexturePackWithFile(String path, boolean firstCall) {
 		for(int i = selectedPacks.size() - 1; i >= 0; i--) {
 			TexturePack texturePack = selectedPacks.get(i);
 			if(texturePack.hasFile(path)) {
diff --git a/src/main/java/net/minecraft/core/block/BasketBlock.java b/src/main/java/net/minecraft/core/block/BasketBlock.java
index bcd5444d5..cad26398e 100644
--- a/src/main/java/net/minecraft/core/block/BasketBlock.java
+++ b/src/main/java/net/minecraft/core/block/BasketBlock.java
@@ -58,15 +58,6 @@ public class BasketBlock extends EntityBlock
         return false;
     }
 
-    @Override
-    public void onBlockRemoved(final World world, final int x, final int y, final int z, int data)
-    {
-        final BasketBlockEntity te = (BasketBlockEntity) world.getBlockEntity(x, y, z);
-        world.removeBlockTileEntity(x, y, z);
-        if (world.isClientSide) return;
-        te.dropAllItems();
-    }
-
 
     @Override
     public boolean isSignalSource()
@@ -80,9 +71,9 @@ public class BasketBlock extends EntityBlock
         return getSignal(world, x, y, z, side);
     }
     @Override
-    public boolean getSignal(WorldSource blockAccess, int x, int y, int z, Side side)
+    public boolean getSignal(WorldSource worldSource, int x, int y, int z, Side side)
     {
-        BasketBlockEntity basketTileEntity = (BasketBlockEntity) blockAccess.getBlockEntity(x, y, z);
+        BasketBlockEntity basketTileEntity = (BasketBlockEntity) worldSource.getBlockEntity(x, y, z);
         if(basketTileEntity != null){
             return basketTileEntity.getNumUnitsInside() == basketTileEntity.getMaxUnits();
         }
diff --git a/src/main/java/net/minecraft/core/block/Block.java b/src/main/java/net/minecraft/core/block/Block.java
index 068207e88..8ec497308 100644
--- a/src/main/java/net/minecraft/core/block/Block.java
+++ b/src/main/java/net/minecraft/core/block/Block.java
@@ -184,7 +184,7 @@ public class Block
         return this.canPlaceOnSurface();
     }
 
-    public boolean renderAsNormalBlockOnCondition(World world, int x, int y, int z)
+    public boolean renderAsNormalBlockOnCondition(WorldSource world, int x, int y, int z)
     {
         return isCubeShaped();
     }
@@ -564,7 +564,10 @@ public class Block
     {
     }
 
-    public boolean getSignal(WorldSource blockAccess, int x, int y, int z, Side side)
+    /**
+     * Gets the redstone signal output by the block itself, i.e. the power it will provide to any immediately adjacent redstone components.
+     */
+    public boolean getSignal(WorldSource worldSource, int x, int y, int z, Side side)
     {
         return false;
     }
@@ -578,6 +581,9 @@ public class Block
     {
     }
 
+    /**
+     * Gets the redstone signal pushed into adjacent solid blocks. Any block experiencing *direct* signal will power itself and all adjacent blocks.
+     */
     public boolean getDirectSignal(World world, int x, int y, int z, Side side)
     {
         return false;
diff --git a/src/main/java/net/minecraft/core/block/Blocks.java b/src/main/java/net/minecraft/core/block/Blocks.java
index 000a8528f..be800a530 100644
--- a/src/main/java/net/minecraft/core/block/Blocks.java
+++ b/src/main/java/net/minecraft/core/block/Blocks.java
@@ -964,16 +964,16 @@ public final class Blocks {
         DISPENSER_COBBLE_STONE = new DispenserBlock("dispenser.cobble.stone", "minecraft:block/dispenser_cobble_stone", 560).withSound(BlockSounds.STONE).withHardness(3.5F).withDisabledNeighborNotifyOnMetadataChange().withImmovableFlagSet()
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);;
 
-        TRAPDOOR_PLANKS_OAK = new TrapDoorBlock("trapdoor.planks.oak", "minecraft:block/trapdoor_planks_oak", 570, Material.wood, false).withSound(BlockSounds.WOOD).withHardness(3F).withDisabledNeighborNotifyOnMetadataChange()
+        TRAPDOOR_PLANKS_OAK = new TrapDoorBlock("trapdoor.planks.oak", "minecraft:block/trapdoor_planks_oak", 570, Material.wood).withSound(BlockSounds.WOOD).withHardness(3F).withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.MINEABLE_BY_AXE);
-        TRAPDOOR_IRON = new TrapDoorBlock("trapdoor.iron", "minecraft:block/trapdoor_iron", 571, Material.metal, true).withSound(BlockSounds.METAL).withHardness(5F).withDisabledNeighborNotifyOnMetadataChange().withOverrideColor(MaterialColor.iron)
+        TRAPDOOR_IRON = new TrapDoorBlock("trapdoor.iron", "minecraft:block/trapdoor_iron", 571, Material.metal).withSound(BlockSounds.METAL).withHardness(5F).withDisabledNeighborNotifyOnMetadataChange().withOverrideColor(MaterialColor.iron)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
-        TRAPDOOR_GLASS = new TrapDoorBlock("trapdoor.glass", "minecraft:block/trapdoor_glass", 572, Material.glass, false).withSound(BlockSounds.GLASS).withHardness(0.3F).withDisabledNeighborNotifyOnMetadataChange()
+        TRAPDOOR_GLASS = new TrapDoorBlock("trapdoor.glass", "minecraft:block/trapdoor_glass", 572, Material.glass).withSound(BlockSounds.GLASS).withHardness(0.3F).withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
         TRAPDOOR_PLANKS_PAINTED = new PaintedTrapDoorBlock("trapdoor.planks.oak.painted", "minecraft:block/trapdoor_planks_oak_painted", 573, Material.wood).withSound(BlockSounds.WOOD).withHardness(3F).withDisabledNeighborNotifyOnMetadataChange()
             .setBlockItem((b) -> new PaintedBlockItem(b, true))
             .withTags(BlockTags.MINEABLE_BY_AXE);
-        TRAPDOOR_STEEL = new TrapDoorBlock("trapdoor.steel", "minecraft:block/trapdoor_steel", 574, Material.metal, true).withSound(BlockSounds.METAL).withHardness(5F).withBlastResistance(2000F).withDisabledNeighborNotifyOnMetadataChange().withOverrideColor(MaterialColor.steel)
+        TRAPDOOR_STEEL = new TrapDoorBlock("trapdoor.steel", "minecraft:block/trapdoor_steel", 574, Material.metal).withSound(BlockSounds.METAL).withHardness(5F).withBlastResistance(2000F).withDisabledNeighborNotifyOnMetadataChange().withOverrideColor(MaterialColor.steel)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
 
         TNT = new TNTBlock("tnt", "minecraft:block/tnt", 580).withSound(BlockSounds.GRASS).withHardness(0.0F);
diff --git a/src/main/java/net/minecraft/core/block/ButtonBlock.java b/src/main/java/net/minecraft/core/block/ButtonBlock.java
index df7864c37..dd5884682 100644
--- a/src/main/java/net/minecraft/core/block/ButtonBlock.java
+++ b/src/main/java/net/minecraft/core/block/ButtonBlock.java
@@ -278,9 +278,9 @@ public class ButtonBlock extends Block
     }
 
     @Override
-    public boolean getSignal(WorldSource blockAccess, int x, int y, int z, Side side)
+    public boolean getSignal(WorldSource worldSource, int x, int y, int z, Side side)
     {
-        return (blockAccess.getBlockMetadata(x, y, z) & 8) > 0;
+        return (worldSource.getBlockMetadata(x, y, z) & 8) > 0;
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/block/ChestBlock.java b/src/main/java/net/minecraft/core/block/ChestBlock.java
index ed88a7ba5..8565a79de 100644
--- a/src/main/java/net/minecraft/core/block/ChestBlock.java
+++ b/src/main/java/net/minecraft/core/block/ChestBlock.java
@@ -135,12 +135,6 @@ public class ChestBlock extends EntityBlock {
 		world.setBlockMetadata(x, y, z, meta);
 	}
 	
-	@Override
-	public void onBlockRemoved(World world, int x, int y, int z, int data) {
-		dropChestContent(world, x, y, z);
-		super.onBlockRemoved(world, x, y, z, data);
-	}
-	
 	public void checkIfOtherHalfExists(World world, int x, int y, int z) {
 		int meta = world.getBlockMetadata(x, y, z);
 		Type type = getTypeFromMeta(meta);
@@ -190,25 +184,7 @@ public class ChestBlock extends EntityBlock {
 		super.onNeighborBlockChange(world, x, y, z, blockId);
 		checkIfOtherHalfExists(world, x, y, z);
 	}
-	
-	public static void dropChestContent(World world, int x, int y, int z) {
-		ChestBlockEntity tileEntityChest = (ChestBlockEntity) world.getBlockEntity(x, y, z);
-		if(tileEntityChest == null) {
-            LOGGER.warn("Can't drop chest items because tile entity is null at x:{}, y:{}, z:{}", x, y, z);
-			return;
-		}
-		
-		for(int i = 0; i < tileEntityChest.getContainerSize(); i++) {
-			ItemStack itemStack = tileEntityChest.getItem(i);
-			if(itemStack == null) continue;
-			ItemEntity item = world.dropItem(x, y, z, itemStack);
-			item.xd *= 0.5;
-			item.yd *= 0.5;
-			item.zd *= 0.5;
-			item.pickupDelay = 0;
-		}
-	}
-	
+
 	public static boolean isChest(World world, int x, int y, int z) {
 		return Block.blocksList[world.getBlockId(x, y, z)] instanceof ChestBlock;
 	}
diff --git a/src/main/java/net/minecraft/core/block/DispenserBlock.java b/src/main/java/net/minecraft/core/block/DispenserBlock.java
index 877949a84..fd02b04f7 100644
--- a/src/main/java/net/minecraft/core/block/DispenserBlock.java
+++ b/src/main/java/net/minecraft/core/block/DispenserBlock.java
@@ -24,13 +24,9 @@ import net.minecraft.core.block.material.Material;
 
 public class DispenserBlock extends RotatableEntityBlock
 {
-    private Random random;
-
-
 	public DispenserBlock(String key, String namespaceId, int id)
     {
         super(key, namespaceId, id, Material.stone);
-        random = new Random();
     }
 
     @Override
@@ -85,8 +81,8 @@ public class DispenserBlock extends RotatableEntityBlock
             return true;
         } else
         {
-            DispenserBlockEntity tileentitydispenser = (DispenserBlockEntity)world.getBlockEntity(x, y, z);
-            player.displayDispenserScreen(tileentitydispenser);
+            DispenserBlockEntity dispenserBlockEntity = (DispenserBlockEntity)world.getBlockEntity(x, y, z);
+            player.displayDispenserScreen(dispenserBlockEntity);
             return true;
         }
     }
@@ -160,7 +156,7 @@ public class DispenserBlock extends RotatableEntityBlock
     {
         if(blockId > 0 && Block.blocksList[blockId].isSignalSource())
         {
-            boolean flag = world.isBlockIndirectlyGettingPowered(x, y, z) || world.isBlockIndirectlyGettingPowered(x, y + 1, z);
+            boolean flag = world.hasNeighborSignal(x, y, z) || world.hasNeighborSignal(x, y + 1, z);
             if(flag)
             {
                 world.scheduleBlockUpdate(x, y, z, id, tickDelay());
@@ -171,7 +167,7 @@ public class DispenserBlock extends RotatableEntityBlock
     @Override
 	public void updateTick(World world, int x, int y, int z, Random rand)
     {
-        if(world.isBlockIndirectlyGettingPowered(x, y, z) || world.isBlockIndirectlyGettingPowered(x, y + 1, z))
+        if(world.hasNeighborSignal(x, y, z) || world.hasNeighborSignal(x, y + 1, z))
         {
             dispenseItem(world, x, y, z, rand);
         }
@@ -183,39 +179,4 @@ public class DispenserBlock extends RotatableEntityBlock
         return new DispenserBlockEntity();
     }
 
-    @Override
-    public void onBlockRemoved(World world, int x, int y, int z, int data)
-    {
-        if(world.getBlockEntity(x, y, z) != null) {
-            DispenserBlockEntity tileentitydispenser = (DispenserBlockEntity) world.getBlockEntity(x, y, z);
-            label0:
-            for (int l = 0; l < tileentitydispenser.getContainerSize(); l++) {
-                ItemStack itemstack = tileentitydispenser.getItem(l);
-                if (itemstack == null) {
-                    continue;
-                }
-                float f = random.nextFloat() * 0.8F + 0.1F;
-                float f1 = random.nextFloat() * 0.8F + 0.1F;
-                float f2 = random.nextFloat() * 0.8F + 0.1F;
-                do {
-                    if (itemstack.stackSize <= 0) {
-                        continue label0;
-                    }
-                    int i1 = random.nextInt(21) + 10;
-                    if (i1 > itemstack.stackSize) {
-                        i1 = itemstack.stackSize;
-                    }
-                    itemstack.stackSize -= i1;
-                    ItemEntity entityitem = new ItemEntity(world, (float) x + f, (float) y + f1, (float) z + f2, new ItemStack(itemstack.itemID, i1, itemstack.getMetadata()));
-                    float f3 = 0.05F;
-                    entityitem.xd = (float) random.nextGaussian() * f3;
-                    entityitem.yd = (float) random.nextGaussian() * f3 + 0.2F;
-                    entityitem.zd = (float) random.nextGaussian() * f3;
-                    world.entityJoinedWorld(entityitem);
-                } while (true);
-            }
-        }
-
-        super.onBlockRemoved(world, x, y, z, data);
-    }
 }
diff --git a/src/main/java/net/minecraft/core/block/DoorBlock.java b/src/main/java/net/minecraft/core/block/DoorBlock.java
index ad251043e..e0fd691f5 100644
--- a/src/main/java/net/minecraft/core/block/DoorBlock.java
+++ b/src/main/java/net/minecraft/core/block/DoorBlock.java
@@ -3,13 +3,13 @@ package net.minecraft.core.block;
 import java.util.Random;
 import java.util.function.Supplier;
 
+import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Item;
-import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.tag.ItemTags;
 import net.minecraft.core.util.helper.Side;
@@ -18,7 +18,6 @@ import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
-import net.minecraft.core.world.save.LevelData;
 import org.jetbrains.annotations.Nullable;
 
 // Referenced classes of package net.minecraft.src:
@@ -51,6 +50,21 @@ public class DoorBlock extends Block
         }
     }
 
+    @Override
+    public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
+        super.onBlockPlacedByMob(world, x, y, z, side, mob, sideHeight);
+
+        int meta = world.getBlockMetadata(x, y, z);
+        if(world.hasNeighborSignal(x, y, z)) {
+            world.setBlockMetadataWithNotify(x, y, z, meta | 4);
+            if (isTop) {
+                world.setBlockMetadataWithNotify(x, y - 1, z, meta | 4);
+            } else {
+                world.setBlockMetadataWithNotify(x, y + 1, z, meta | 4);
+            }
+        }
+    }
+
     @Override
 	public boolean isSolidRender()
     {
@@ -221,7 +235,7 @@ public class DoorBlock extends Block
             } else
             if(blockId > 0 && Block.blocksList[blockId].isSignalSource())
             {
-                boolean flag1 = world.isBlockIndirectlyGettingPowered(x, y, z) || world.isBlockIndirectlyGettingPowered(x, y + 1, z);
+                boolean flag1 = world.hasNeighborSignal(x, y, z) || world.hasNeighborSignal(x, y + 1, z);
                 onPoweredBlockChange(world, x, y, z, flag1);
             }
         }
diff --git a/src/main/java/net/minecraft/core/block/EntityBlock.java b/src/main/java/net/minecraft/core/block/EntityBlock.java
index 7625c31d5..7ca686827 100644
--- a/src/main/java/net/minecraft/core/block/EntityBlock.java
+++ b/src/main/java/net/minecraft/core/block/EntityBlock.java
@@ -28,6 +28,12 @@ public abstract class EntityBlock extends Block
     public void onBlockRemoved(World world, int x, int y, int z, int data)
     {
         super.onBlockRemoved(world, x, y, z, data);
+        if (!world.isClientSide) {
+            BlockEntity blockEntity = world.getBlockEntity(x, y, z);
+            if(blockEntity != null) {
+                blockEntity.dropContents(world, x, y, z);
+            }
+        }
         world.removeBlockTileEntity(x, y, z);
     }
 
diff --git a/src/main/java/net/minecraft/core/block/FurnaceBlock.java b/src/main/java/net/minecraft/core/block/FurnaceBlock.java
index 69c2ce2bd..c7a414eb4 100644
--- a/src/main/java/net/minecraft/core/block/FurnaceBlock.java
+++ b/src/main/java/net/minecraft/core/block/FurnaceBlock.java
@@ -11,6 +11,7 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
 import org.slf4j.Logger;
 
 import java.util.Random;
@@ -27,7 +28,6 @@ public class FurnaceBlock extends RotatableEntityBlock
 	public FurnaceBlock(String key, String namespaceId, int id, boolean flag)
     {
         super(key, namespaceId, id, Material.stone);
-        furnaceRand = new Random();
         isActive = flag;
     }
 
@@ -98,7 +98,7 @@ public class FurnaceBlock extends RotatableEntityBlock
         return true;
     }
 
-	public static void updateFurnaceBlockState(boolean lit, World world, int x, int y, int z) {
+	public static void updateFurnaceBlockState(boolean lit, @NotNull World world, int x, int y, int z) {
 		int meta = world.getBlockMetadata(x, y, z);
 		BlockEntity blockEntity = world.getBlockEntity(x, y, z);
 		if(blockEntity == null) {
@@ -127,51 +127,9 @@ public class FurnaceBlock extends RotatableEntityBlock
     {
         return new FurnaceBlockEntity();
     }
-    
-    @Override
-    public void onBlockRemoved(World world, int x, int y, int z, int data)
-    {
-        if(!keepFurnaceInventory)
-        {
-            FurnaceBlockEntity tileentityfurnace = (FurnaceBlockEntity)world.getBlockEntity(x, y, z);
-label0:
-            for(int l = 0; l < tileentityfurnace.getContainerSize(); l++)
-            {
-                ItemStack itemstack = tileentityfurnace.getItem(l);
-                if(itemstack == null)
-                {
-                    continue;
-                }
-                float f = furnaceRand.nextFloat() * 0.8F + 0.1F;
-                float f1 = furnaceRand.nextFloat() * 0.8F + 0.1F;
-                float f2 = furnaceRand.nextFloat() * 0.8F + 0.1F;
-                do
-                {
-                    if(itemstack.stackSize <= 0)
-                    {
-                        continue label0;
-                    }
-                    int i1 = furnaceRand.nextInt(21) + 10;
-                    if(i1 > itemstack.stackSize)
-                    {
-                        i1 = itemstack.stackSize;
-                    }
-                    itemstack.stackSize -= i1;
-                    ItemEntity entityitem = new ItemEntity(world, (float) x + f, (float) y + f1, (float) z + f2, new ItemStack(itemstack.itemID, i1, itemstack.getMetadata()));
-                    float f3 = 0.05F;
-                    entityitem.xd = (float)furnaceRand.nextGaussian() * f3;
-                    entityitem.yd = (float)furnaceRand.nextGaussian() * f3 + 0.2F;
-                    entityitem.zd = (float)furnaceRand.nextGaussian() * f3;
-                    world.entityJoinedWorld(entityitem);
-                } while(true);
-            }
-
-        }
-        super.onBlockRemoved(world, x, y, z, data);
-    }
 
     protected Random furnaceRand;
     protected final boolean isActive;
-    protected static boolean keepFurnaceInventory = false;
+    public static boolean keepFurnaceInventory = false;
 
 }
diff --git a/src/main/java/net/minecraft/core/block/GoldMeshBlock.java b/src/main/java/net/minecraft/core/block/GoldMeshBlock.java
index 989f44716..4ab8cd9c2 100644
--- a/src/main/java/net/minecraft/core/block/GoldMeshBlock.java
+++ b/src/main/java/net/minecraft/core/block/GoldMeshBlock.java
@@ -43,22 +43,10 @@ public class GoldMeshBlock extends EntityBlock {
         boolean flag = meshGold.setFilterItem(player, heldItem);
         if(heldItem != null && heldItem.stackSize <= 0)
         {
-            player.inventory.setItem(player.inventory.currentItem, null);
+            player.inventory.setItem(player.inventory.getCurrentItemIndex(), null);
         }
         return flag;
     }
-    @Override
-    public void onBlockRemoved(World world, int x, int y, int z, int data) {
-        GoldMeshBlockEntity mesh = (GoldMeshBlockEntity) world.getBlockEntity(x, y, z);
-        if (mesh.filterItem != null){
-            ItemEntity item = world.dropItem(x, y, z, mesh.filterItem);
-            item.xd *= 0.5;
-            item.yd *= 0.5;
-            item.zd *= 0.5;
-            item.pickupDelay = 0;
-        }
-        super.onBlockRemoved(world, x, y, z, data);
-    }
 
     @Override
     public boolean collidesWithEntity(Entity entity, World world, int x, int y, int z) {
